<?php 


//Returns a set value. If unset, returns ''
function rfk_SafeRead(&$pVar) {
	if (isset($pVar)) return $pVar;
	else return '';
}

class rfk {
	public $Scr='';			//Rendered playground
	public $Pan='';			//Rendered control panel
	public $Out;			//Whole rendered HTML
	public $CFS;			//Custom Form String
	
	public $V;				//Object vars array (passed from SESSIONS)
		//Start					==TRUE if game restart
		//Step					INTRO / GAME / WIN
		//Msg;					Current message
		//Scr_SX;				Screen : Playground : width
		//Scr_SY;				Screen : Plauground : height
		//Bog_Num;				Bogus : Number of...
		//Bog_Off;				Bogus : Screen offset array
		//Bog_Car;				Bogus : Char for dispay
		//Bog_Col;				Bogus : color for dispay  
		//Bog_Bol;				Bogus : Bold display ?
		//Bog_Msg;				Bogus : Message Key
		//Kit_Bog				Index of the Kitten-Bogus
		//Rob_Off;				Robot : Offset

	//**DEFS
	public $dVERSION;		//Dispalyed version
	public $sScrStyle;	//Playground style
	public $dRobotDisplay;	//HTML string for the root rendering
	public $dCol;			//font color array
	public $dChr;			//Chars array
	public $dMsg;			//Messages array	
	public $dWinFrame;		//Win panel lines array 
	public $dWinWidth;		//(in chars)
	public $dWinHeight;		//(in chars)
	public $dWinLines;		//Win panel nuber of lines
	public $dWinMessage;	//Displayed message	
	
	
	//**Render a space right padded fitting screen width
	public function Scr_StrPadded($pStr) {
		$pStr=str_replace("  ","&nbsp;&nbsp;",$pStr);
		$this->Scr.=$pStr.str_repeat('&nbsp;',$this->V['Scr_SX']-strlen(preg_replace(
			array('#<.*>#U',"#&.*;#U"),
			array('','?'),
		$pStr))).'<br>';			
	}
	
	//**Render upper part screen (version/message/separator)
	public function Scr_Message() {														
		$this->Scr_StrPadded($this->dVERSION);											
		$this->Scr_StrPadded($this->V['Msg']);										
		$this->Scr.=str_repeat('_',$this->V['Scr_SX']).'<br>';							
	}
	
	//**Render the given bogus
	public function Scr_Bogus($pBogus) {												
		$Tmp=$this->dChr[$this->V['Bog_Car'][$pBogus]];								
		if ($this->V['Bog_Bol'][$pBogus]==1)	$Tmp='<b>'.$Tmp.'</b>';
		$this->Scr.='<font color="#'.$this->dCol[$this->V['Bog_Col'][$pBogus]].'">'.$Tmp.'</font>';
	}
	
	//**Intro screen
	public function Scr_Intro() {
			$this->Scr_StrPadded("");
			$this->Scr_StrPadded($this->dVERSION);
			$this->Scr_StrPadded("By the illustrious Leonard Richardson (C) 1997, 2000");
			$this->Scr_StrPadded("Written originally for the Nerth Pork robotfindskitten contest");
			$this->Scr_StrPadded("Written for PHP/HTML by Xavier Darmon (2012)");
			$this->Scr_StrPadded("");
			$this->Scr_StrPadded('In this game, you are robot ('.$this->dRobotDisplay.'). Your job is to find kitten. This task');
			$this->Scr_StrPadded("is complicated by the existence of various things which are not kitten.");
			$this->Scr_StrPadded("Robot must touch items to determine if they are kitten or not. The game");
			$this->Scr_StrPadded("ends when robotfindskitten. Alternatively, you may end the game by browsing");
			$this->Scr_StrPadded('to antother place. See the <a href="http://robotfindskitten.org/">official website</a> for more information.');
			$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded("");
			$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded("");
			$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); 
	}
	
	public function Scr_Error() {
		$this->Scr_StrPadded("");
		$this->Scr_StrPadded("                            ***************");
		$this->Scr_StrPadded("                            **** ERROR ****");
		$this->Scr_StrPadded("                            ***************");
		$this->Scr_StrPadded("  'Screen Width' must be a numeric value between 80 and 160");
		$this->Scr_StrPadded("  'Screen Heigth' must be a numeric value between 10 and 160");
		$this->Scr_StrPadded("  'NonKitten Objects' must be a numeric value between 0 and 400");
		$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded("");
		$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded("");
		$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded("");
		$this->Scr_StrPadded(""); $this->Scr_StrPadded(""); $this->Scr_StrPadded(""); 			
	}
	
	//**Intro panel 
	public function Pan_Intro() {
		$this->Pan='	
			<form action="./" method="get">'.
				$this->CFS.'
				<input type="hidden"  name="cmd"  value="NEW">
				<table><tr>
					<td>Screen Width :</td><td><input type="text" name="sizeX" value = "'.$this->V['Scr_SX'].'" /></td>
					</tr><tr>
					<td>Screen Height :</td><td><input type="text" name="sizeY" value = "'.$this->V['Scr_SY'].'"/></td>
					</tr><tr>
					<td>Non-kitten objects :</td><td><input type="text" name="nko" value = "'.($this->V['Bog_Num']-1).'"/></td>
					</tr><tr><td colspan=2>
						<button type="submit" style="width:100%">New Game</button> 
					</td></tr>			
				</table>
			</form>
		';
	}

	//**Control panel
	public function Pan_Control() {
		function Pan_Control_Make($pCmd,$pCFS) {
			if ($pCmd!='') {
				return "<form action=\"./\">
							$pCFS
							<input type=\"hidden\"  name=\"cmd\"  value=\"$pCmd\">
							<button type=\"submit\" style=\"width:100%\">$pCmd</button> 
						</form>";
			}
			else {
				return 
						"<form action=\"./\">
							<input type=\"hidden\"  name=\"cmd\"  value=\"$pCmd\">
							<button type=\"submit\" style=\"width:100%\" disabled>$pCmd</button> 
						</form>";				
			}			
		}//--Pan_Control_Make
		$this->Pan.='<table>';
		if ($this->V['Step']=='GAME') {
			$this->Pan.='<tr><td colspan=3>Direction buttons</td></tr>';		    
			$this->Pan.='<tr><td>'.Pan_Control_Make("NW",$this->CFS).'</td><td>'.Pan_Control_Make("N",$this->CFS).'</td><td>'.Pan_Control_Make("NE",$this->CFS).'</td></tr>';
			$this->Pan.='<tr><td>'.Pan_Control_Make("W",$this->CFS).'</td><td>'.Pan_Control_Make("",$this->CFS).'</td><td>'.Pan_Control_Make("E",$this->CFS).'</td></tr>';
			$this->Pan.='<tr><td>'.Pan_Control_Make("SW",$this->CFS).'</td><td>'.Pan_Control_Make("S",$this->CFS).'</td><td>'.Pan_Control_Make("SE",$this->CFS).'</td></tr>';
		}
		$this->Pan.='<tr><td colspan=3>Menu</td></tr>';
		$this->Pan.='<tr><td colspan=3>'.Pan_Control_Make("NEW",$this->CFS).'</td></tr>';
		$this->Pan.='<tr><td colspan=3>'.Pan_Control_Make("RESET",$this->CFS).'</td></tr>';
		$this->Pan.='</table>';

	}
	
	public function Scr_Ingame() {
		$this->Scr_Message();
		$J=0;
		for ($I=0;$I<$this->V['Scr_SX']*$this->V['Scr_SY'];$I++) {
			if (($I>0)&&(($I%$this->V['Scr_SX'])==0)) $this->Scr.='<br>';
			if ($I==$this->V['Bog_Off'][$J]) 
				$this->Scr_Bogus($J++);
			else if ($I==$this->V['Rob_Off'])
				$this->Scr.=$this->dRobotDisplay;
			else $this->Scr.='&nbsp;';			
		}//-for
	}
	
	public function Scr_Win() {
		$this->Scr_Message();
		//*Compute frame position ($dWinY)	
		$dWinY=floor(($this->V['Scr_SY']-$this->dWinHeight)/2);
		for ($I=0;$I<$this->V['Scr_SY'];$I++) 
			if (($I>=$dWinY)&&($I<$dWinY+$this->dWinHeight))	
				$this->Scr_StrPadded(str_pad(" ",floor(($this->V['Scr_SX']-$this->dWinWidth)/2)," ").$this->dWinLines[$I-$dWinY]);
				else $this->Scr_StrPadded("");																	
	}																						
	

	public function Init_FeedArrayRandUnique(&$pVar,$pSize,$pDown,$pUp) {
		$pVar=array();
		for ($I=0;$I<$pSize;$I++) {
			$Tmp=rand($pDown,$pUp);
			if (in_array($Tmp,$pVar))	{$I--;	continue;}
			array_push($pVar,$Tmp);					
		}//for
	}	
		
	public function init_NewGame() {												//**Set a new plaground
		$this->V['Msg']='';	
		//Init Bog_Off : An unique offset, sorted 
		$this->Init_FeedArrayRandUnique($this->V['Bog_Off'],$this->V['Bog_Num'],0,$this->V['Scr_SX']*$this->V['Scr_SY']);
		sort($this->V['Bog_Off']);
		array_push($this->V['Bog_Off'],'');
		//Init Msg : An unique message		
		$this->Init_FeedArrayRandUnique($this->V['Bog_Msg'],$this->V['Bog_Num'],0,count($this->dMsg)-1);
		//Car Col Bol : taken from arrays, 'null' terminated
		$this->V['Bog_Car']=array();															
		$this->V['Bog_Col']=array();															
		$this->V['Bog_Bol']=array();															
		for ($I=0;$I<$this->V['Bog_Num'];$I++)	{
			$this->V['Bog_Car'][$I]=array_rand($this->dChr);
			$this->V['Bog_Col'][$I]=array_rand($this->dCol);
			$this->V['Bog_Bol'][$I]=rand(0,1);
		}
		array_push($this->V['Bog_Car'],'');							
		array_push($this->V['Bog_Col'],'');							
		array_push($this->V['Bog_Bol'],'');	
		//Rob_Off : must be different from any Bog_Off
		do {
			$this->V['Rob_Off']=rand(0,$this->V['Scr_SX']*$this->V['Scr_SY']);
		} while (in_array($this->V['Rob_Off'],$this->V['Bog_Off']));		
		//Choose a kitten among all bogus																			
		$this->V['Kit_Bog']=rand(0,$this->V['Bog_Num']-1);						
	}	
		
	public function Move_Robot($pDir) {
		//Rob X/Y : Current coords ret
		$Rob_X=$this->V['Rob_Off']%$this->V['Scr_SX'];
		$Rob_Y=floor($this->V['Rob_Off']/$this->V['Scr_SX']);
		//New X/Y : New Cords
		switch($pDir) {
			case 'N':	$New_X=$Rob_X*1;	$New_Y=$Rob_Y-1;	break;
			case 'NE':	$New_X=$Rob_X+1;	$New_Y=$Rob_Y-1;	break;
			case 'E':	$New_X=$Rob_X+1;	$New_Y=$Rob_Y*1;	break;
			case 'SE':	$New_X=$Rob_X+1;	$New_Y=$Rob_Y+1;	break;
			case 'S':	$New_X=$Rob_X*1;	$New_Y=$Rob_Y+1;	break;
			case 'SW':	$New_X=$Rob_X-1;	$New_Y=$Rob_Y+1;	break;
			case 'W':	$New_X=$Rob_X-1;	$New_Y=$Rob_Y*1;	break;
			case 'NW':	$New_X=$Rob_X-1;	$New_Y=$Rob_Y-1;	break;
			case 'NEW':	return;																	//No command
			default: 	$this->V['Msg']='Invalid input: Use direction buttons.'; return;		//Bad command								
		}//-switch pDir
		//Abord if out of screen
		if (($New_X<0)||($New_X>=$this->V['Scr_SX'])||($New_Y<0)||($New_Y>=$this->V['Scr_SY']))
			return;
		$New_Off=$New_X+$New_Y*$this->V['Scr_SX'];												//Compute new offset
		//if a bogus in in the aimed new offset
		for ($I=0;;) {
			if ($New_Off==$this->V['Bog_Off'][$I]) {											//	If object found
				if ($this->V['Kit_Bog']==$I) {													//		See if the object is a kitten
					$this->V['Step']='WIN';														//			Set new step
					$this->V['Msg']=$this->dWinMessage;											//			Clear message 
					return;}																	//			-leave		
				$this->V['Msg']=$this->dMsg[$this->V['Bog_Msg'][$I]];							//		Set screen messag
				return;																			//		leave
			}																					//	--if
			$I++;																				//	Next bogus
			if ($I>=$this->V['Bog_Num'])	break;												//	Leave at end of array
		}																						//--for
		$this->V['Rob_Off']=$New_Off;															//Set new offset		
	}
		
	public function __construct($pCustomFormString) {
		$this->CFS=$pCustomFormString;		
		//Load definitions
		require 'rfk_def.php';
		//Step Splash : no session or RESET comand																
		if	((rfk_SafeRead($_SESSION['rfk'])=='')||
		 (rfk_SafeRead($_GET['cmd'])=='RESET')) {
			//Reset vars, Intro screen
			$this->V='';
			$this->V['Start']=FALSE;
			$this->V['Step']='INIT';
			$this->V['Scr_SX']=80;															
			$this->V['Scr_SY']=19;														
			$this->V['Bog_Num']=20;														
			$this->Scr_Intro();		
			$this->Pan_Intro();										
		}//Step Splash
		elseif ((rfk_SafeRead($_GET['cmd'])=='NEW')||
		(rfk_SafeRead($_SESSION['rfk']['Step'])=='INIT')) {
			$this->V=$_SESSION['rfk'];
			//Recall previous parameters if passed in the commandline
			if ((isset($_GET['nko']))&&(is_numeric($_GET['nko']))) $_GET['nko']++; 
			if (!isset($this->V['Scr_SX']))	$this->V['Scr_SX']=80;
			if (!isset($this->V['Scr_SY']))	$this->V['Scr_SY']=19;
			if (!isset($this->V['Bog_Num']))$this->V['Bog_Num']=20;
			if (isset($_GET['sizeX']))	$this->V['Scr_SX']=$_GET['sizeX'];
			if (isset($_GET['sizeY']))	$this->V['Scr_SY']=$_GET['sizeY'];
			if (isset($_GET['nko']))	$this->V['Bog_Num']=$_GET['nko'];			
			//Chk validity
			if ((is_numeric($this->V['Scr_SX']))&&(is_numeric($this->V['Scr_SY']))&&(is_numeric($this->V['Bog_Num']))&&
			 ($this->V['Scr_SX']>=80)&&($this->V['Scr_SY']>=10)&&
			 ($this->V['Scr_SX']<=160)&&($this->V['Scr_SY']<=160)&&
			 ($this->V['Bog_Num']>=0)&&($this->V['Bog_Num']<=401)) {
				$this->V['Start']=TRUE;
				$this->init_NewGame();
				$this->V['Step']='GAME';
				$this->Scr_Ingame();
				$this->Pan_Control();
			}//if valid
			else {//Not valid
				$this->V['Start']=FALSE;
				$this->V['Scr_SX']=80;
				$this->V['Scr_SY']=19;
				$this->Scr_Error();		
				$this->Pan_Intro();
			}//-not valid		
		}//Step Post-intro
		//Step : GAME	
		else  {/* STEP : GAME / WIN*/
			$this->V=$_SESSION['rfk'];
			$this->V['Start']=FALSE;
			$this->Move_Robot(rfk_SafeRead($_GET['cmd']));
			if ($this->V['Step']=='GAME')	$this->Scr_Ingame();
			else							{$this->Scr_Win();$this->V['Start']=TRUE;}
			$this->Pan_Control();
		}//-Step Game
		//Render HTML $Out
		$this->Out="
			<table><tr><td>
				<span style=\"$this->sScrStyle\">
  					$this->Scr
  				</span></td>  				
 				<td>$this->Pan</td>
			</tr></table>";
		//Save Session													
		$_SESSION['rfk']=$this->V;										
	}//--function __construct	
}//--class rfk


?>